################################################################################
# Module to find cfitsio                                                       #
#                                                                              #
# This module defines:                                                         #
#                                                                              #
#   LAPACK_FOUND                                                               #
#   LAPACK_VERSION                                                             #
#   LAPACK_LIBRARIES                                                           #
#   LAPACK_INCLUDE_DIR                                                         #
#   LAPACK_LIB_DIR                                                             #
#   LAPACK_CPPFLAGS                                                            #
#   LAPACK_LDFLAGS                                                             #
################################################################################

SET (LAPACK_FIND_QUIETLY TRUE)
SET (LAPACK_FIND_REQUIRED FALSE)
LIST (APPEND _blas_vendors "Goto" "ATLAS" "Apple" "Generic")

IF (NOT LAPACK_FOUND)

  FOREACH (_vendor ${_blas_vendors})
    SET (BLA_VENDOR ${_vendor})
    FIND_PACKAGE (LAPACK)
    IF (LAPACK_FOUND)
      SET (LAPACK_LDFLAGS "${LAPACK_LIBRARIES}")
      MESSAGE (STATUS "LAPACK found (${_vendor})")
      MESSAGE (STATUS "  * libs:     ${LAPACK_LIBRARIES}")
      BREAK ()
    ENDIF ()
  ENDFOREACH ()

#  FIND_PACKAGE (LAPACK)
#
#  IF (LAPACK_FOUND)
#    # Set flags and print a status message
#    MESSAGE (STATUS "LAPACK version ${LAPACK_VERSION} found:")
#
#    SET (LAPACK_CPPFLAGS "-I${LAPACK_INCLUDE_DIR}")
#    SET (LAPACK_LDFLAGS "${LAPACK_LIBRARIES}")
#    
#    #MESSAGE (STATUS "  * includes: ${LAPACK_INCLUDE_DIR}")
#    MESSAGE (STATUS "  * libs:     ${LAPACK_LIBRARIES}")
#  ENDIF (LAPACK_FOUND)

ENDIF (NOT LAPACK_FOUND)

