
#ifndef PHOTOSPLINE_CORE_SPLINE_TABLE_H
#define PHOTOSPLINE_CORE_SPLINE_TABLE_H

#ifdef __cplusplus
extern "C" {
#endif

struct splinetable {
	int ndim;
	int *order;

	double **knots;
	long *nknots;

	double **extents;

	double *periods;

	float *coefficients;
	long *naxes;
	unsigned long *strides;

	int naux;
	char ***aux;
};

typedef enum {
	SPLINETABLE_INT,
	SPLINETABLE_DOUBLE
} splinetable_dtype;

int readsplinefitstable(const char *path, struct splinetable *table);

void splinetable_free(struct splinetable *table);

char * splinetable_get_key(struct splinetable *table, const char *key);

int splinetable_read_key(struct splinetable *table, splinetable_dtype type,
    const char *key, void *result);

#ifdef __cplusplus
}
#endif

#endif /* PHOTOSPLINE_CORE_SPLINE_TABLE_H */

